/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Thu Jul 19 23:10:26 EEST 2001
    copyright            : (C) 2001 by Tero Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include <string>

#include "game.h"
using namespace std;

string configfilename;

int parse_args( int argc, char *argv[] )
{
	//default cfgpath
	configfilename=string(getenv("HOME"))+string(CONFIGFILE);

	int i;
	for( i=1; i<argc-1; i++ )
	{
		if( !strcmp( argv[i], "-cfgfile" ) )
		{
			i++;
			configfilename=argv[i];
		}
	}
	return 0;
}


int main(int argc, char *argv[])
{	
	Game *executor;
	cout << "Executor version " << VERSION << " by Tero Kontkanen <tkp@myrealbox.com>" << endl;

	if( parse_args( argc, argv ) ) {
		msg::msgOut( MSG_FATAL, "Error parsing arguments" );
	}
	
	msg::setDebugLevel( 4 );
	
	executor = new Game( configfilename );
	executor->initGame();
	executor->mainLoop();
	
	delete executor;
	return EXIT_SUCCESS;
}
