/***************************************************************************
                          targetfinder.cpp  -  description
                             -------------------
    begin                : Sun Nov 4 2001
    copyright            : (C) 2001 by T Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "targetfinder.h"

TargetFinder::TargetFinder( Game *parent, Unit *punit ){
	game=parent;
	thisunit=punit;
	
	setFinderParams(true, true);
	seekfrequency=30;
	seekdistance=100;
	seekcounter=thisunit->myRand()%seekfrequency;
}

TargetFinder::~TargetFinder(){
}

UnitCommand TargetFinder::findTarget()
{
	
	Vector distance;
	float distancef;
	static bool changable=true; // true if target can be changed
	float bestpoints=-999999, points;
	UnitID best;
	
	seekcounter++;
	if( seekcounter > seekfrequency )
		seekcounter=0;
	else return current;


	//calculate points
	for( UnitID it=game->firstUnitID(); !game->iterationEnd(it); game->nextUnitID(it) )
	{
		Unit *u=game->getUnit(it);

		if( u->getUnitSide()==thisunit->getUnitSide() ) continue; //skip if my side
		if( u->getHitpoints()<= 0 ) continue; //skip if dying
//		if( thisunit->isMoving()==false && u->isMoving()==false ) continue;//it's not coming
	
		// calculate distance
		distance=u->getUnitPosition()-thisunit->getUnitPosition();
		distancef=distance.length();
		
		//if potential target
		if( distancef < seekdistance ) {
			//closer is easier target
			points=seekdistance/distancef;
			
			if( u->unitShootingAt()==thisunit->getID() ) //it is shooting at us!
				points+=200;
				
			points+=2*u->getAverageDamage();
			
			if( points>bestpoints ) //better target found
			{
				bestpoints=points;
				best=it;
//				current.setTargetUnit( best );
			}
//			current.setTargetUnit( best );
//			printf("newtarget\n");
//			setTargetUnit( it );
//			return current;
		}
	}
	if( bestpoints > -999999 ) current.setTargetUnit( best );
	
	return current; //no new target found
}

