/***************************************************************************
                          targetfinder.h  -  description
                             -------------------
    begin                : Sun Nov 4 2001
    copyright            : (C) 2001 by T Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TARGETFINDER_H
#define TARGETFINDER_H

#include "unitcommand.h"
#include "unit.h"
#include "unitid.h"
#include "game.h"

/**Unit target finding algorithms.
  *@author T Kontkanen
  */

class TargetFinder {
public: 
	TargetFinder( Game *parent, Unit *punit );
	~TargetFinder();
	/// Searchs a new target. Returns a new target as UnitCommand.
	UnitCommand findTarget();
	/// Set radius where targets are searched from.
	void setSeekDistance( int newseekdistance ) { seekdistance=newseekdistance; }
	/// Set some parameters for target finder. Params shound be self explanative.
	void setFinderParams( bool can_shoot_ground, bool can_shoot_air ) {
		shootair=can_shoot_air;
		shootground=can_shoot_ground;
	}
	
private:
	UnitCommand current;
	Game *game;
	Unit *thisunit;
	int seekcounter, seekfrequency;
	float seekdistance;
	bool  shootair, shootground;
};

#endif
