/***************************************************************************
                          unit.cpp  -  description
                             -------------------
    begin                : Wed Jul 25 2001
    copyright            : (C) 2001 by T Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "unit.h"
#include "player.h"


Unit::Unit( Game *pgame )
{
/*	uRenderer=pgame->renderer;
	primaryActionNum=A_MOVE;	
	bIsSelected=false;*/
	uGame=pgame;
	uRenderer=pgame->renderer;
	uGround=pgame->ground;
	uPlayers=pgame->players;
	
	primaryActionNum=A_NONE;
	setUnitType( STATIC );
	setMaxHitpoints(100);
	setHitpoints(1.0);
	bIsSelected=false;
	mySide=0;
	avgDamage=0;
	avgSize=maxSize=1;
	
	primaryActionType.setActionID(A_NONE);
	
	myRandnum=uGame->rand();
	// create new ID
	myID=uGame->createUnitID( this );
//	myID=myid;
}

Unit::~Unit(){
}

bool Unit::screenSelect( Vector sel1, Vector sel2 )
{
	Vector mypos, *s1, *s2;
	
	//translate unit from 3d to 2d space
	mypos=uRenderer->worldToScreen( getUnitPosition() ); //testgame
//	mypos=uRenderer->worldToScreen( getUnitPosition() );

	//sort x coordinates
	if( sel1.x() > sel2.x() ) {
		s1=&sel2;
		s2=&sel1;
	}
	else {
		s1=&sel1;
		s2=&sel2;
	}	
	
	if( mypos.x() >= s1->x() && mypos.x()<= s2->x() ) //if between s1.x s2.x then continue
	{
		//sort y coordinates
		if( sel1.y() > sel2.y() ) {
			s1=&sel2;
			s2=&sel1;
		}
		else {
			s1=&sel1;
			s2=&sel2;
		}	
		if( mypos.y() >= s1->y() && mypos.y()<= s2->y() ) //if between s1.y s2.y then select
			bIsSelected=true;
		else
			bIsSelected=false;
	} else
		bIsSelected=false;
	
	return bIsSelected;
}

/// Get enemy to which this Unit is attacking. NULL is returned if there is no enemy.
/*Unit *Unit::getTarget()
{
	if( uTargetPlayer==-1 || uTargetNum==-1 ) return NULL;
	if( uGame->players[uTargetPlayer] == NULL ) return NULL;
	if( uGame->players[uTargetPlayer]->units[uTargetNum] == NULL ) return NULL;
	
	return uGame->players[uTargetPlayer]->units[uTargetNum];
}*/

UnitID Unit::getTarget()
{
	return target;
}

/// Set enemy for this Unit. This enemy will be primary target.
/*void Unit::setTarget( Unit *enemy )
{
	int p, u;
	
	///find unit
	for( p=0; p<MAX_PLAYERS; p++ )
	{
		if( uPlayers[p]==NULL ) continue; // no player, skip
		
		for( u=0; u<MAX_UNITS; u++ )
		{
			if(  uPlayers[p]->units[u]==NULL ) continue; // no unt, skip
			
			if( uGame->players[p]->units[u] == enemy )
			{
				uTargetNum=u;
				uTargetPlayer=p;
				return;
			}
		}
	}
	
	//not found
	uTargetNum=-1;
	uTargetPlayer=-1;
}

/// Set enemy for this Unit. This enemy will be primary target.
void Unit::setTarget( int player, int unitnum )
{
	uTargetNum=unitnum;
	uTargetPlayer=player;
	
	///clamp
	if( uTargetNum < 0 || uTargetNum > MAX_UNITS ) uTargetNum=-1;
	if( uTargetPlayer < 0 || uTargetPlayer > MAX_PLAYERS ) uTargetPlayer=-1;
	
}*/

void Unit::setTarget( UnitID enemy )
{
	target=enemy;
}

int Unit::getNumberOfActions()
{
	return 0; //default
}

UnitCommand Unit::getActionType( int number )
{
	msgOut( MSG_WARN, "Attempt to get Unit baseclass action number %d", number );
	
	return primaryActionType;
}

int Unit::action( UnitCommand action )
{
	msgOut( MSG_WARN, "Giving orders for uncontrollable unit" );
	return 0;
}
