/***************************************************************************
                          unitcommandcenter.cpp  -  description
                             -------------------
    begin                : Sun Aug 26 2001
    copyright            : (C) 2001 by T Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "unitcommandcenter.h"


//UnitCommandCenter::UnitCommandCenter( Game *pgame, int myplayernum, int myunitnum ): Unit( pgame ), DummyMovement( pgame )
UnitCommandCenter::UnitCommandCenter( Game *pgame ): Unit( pgame ), DummyMovement( pgame )
{
	game=pgame;
	renderer=pgame->renderer;
	ground=pgame->ground;
	players=pgame->players;
	
//	playerNum=getUnitSide();
//	playerNum=myid.getPlayernum();
//	playerNum=myplayernum;
//	unitNum=myunitnum;
	
	setPrimaryAction( A_BUILD_MARINE );
	
	//set parameters
	setName( "Command Center" );
	setMaxHitpoints( 1500 );
	setHitpoints( 1.0 );
	setUnitType( BUILDING );
	
	//load model
	model=renderer->loadTGLObject( game->dataRoot()+"models/commandcenter.t3d", 20 );
}


UnitCommandCenter::~UnitCommandCenter(){
	renderer->freeTGLObject( MARINE_MODEL );
}

int UnitCommandCenter::render() // render this unit
{
	msg::setFuncName( "UnitCommandCenter::render" );
	renderer->setRenderingMode( RENDER_TGL_OBJECT );
//	model->move( getPosition().x(), getPosition().y(), getPosition().z()+1 );
	model->move( getPosition().x(), getPosition().y(), getPosition().z());
//	model->rotate( 0, 0, 1, RAD_TO_DEG(getAngle()) ); //angle
	model->rotate( 0, 0, 1, RAD_TO_DEG(getAngle()) ); //angle
	model->rotate( 0, 0, 1, 90 );
	model->rotate( 1, 0, 0, 90 );
	
	// morph according to damage
	model->set_morph( 0,1 );
	model->morph( 1-(getHitpoints()/getMaxHitpoints()) );
	
	model->draw();

	return 0;
}

//int UnitCommandCenter::action( int actionnum, Vector destpos )
//{
int UnitCommandCenter::action( UnitCommand action )
{
	int actionnum=action.getActionID();
	Vector destpos=action.getPosition();
	Unit *u;
	
	switch( actionnum ) {
		case A_BUILD_MARINE:
			u=new UnitMarine( game );
			game->getMyPlayer()->insertNewUnit( u );
			u->setUnitPosition( destpos );
			u->setUnitSide(getUnitSide());
			break;
		default: break;
	}
	
	return 0;
}


int UnitCommandCenter::step()
{
	return 0;
}

int UnitCommandCenter::getNumberOfActions()
{
	return 1;
}

UnitCommand UnitCommandCenter::getActionType( int number )
{
	UnitCommand cmd;
	
	switch( number )
	{
		case 0:
			cmd.setActionID(A_BUILD_MARINE);
			cmd.setButtonText("Train Marine");
			cmd.setIcon( game->iconBuildMarine );
			cmd.setTargetRequirement(false);
			break;
		default:
			cmd.setActionID(A_NONE);
			cmd.setButtonText("None");
			cmd.setIcon( game->iconNone );
			cmd.setTargetRequirement(false);
			break;
	}
		
	return cmd;
}
