/***************************************************************************
                          unitcommandcenter.h  -  description
                             -------------------
    begin                : Sun Aug 26 2001
    copyright            : (C) 2001 by T Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UNITCOMMANDCENTER_H
#define UNITCOMMANDCENTER_H

/**Command center building
  *@author T Kontkanen
  */

#include "renderer.h"
#include "player.h"
#include "ground.h"
#include "allincludes.h"
#include "gamedefs.h"
#include "vector.h"
#include "dummymovement.h"
#include "unit.h"
#include "unitmarine.h"

/**Marine unit
  *@author T Kontkanen
  */

class Player;
class Unit;

using namespace TGL;

class Game;

class UnitCommandCenter : public Unit, DummyMovement {
public:
//	UnitCommandCenter::UnitCommandCenter( Game *pgame, int myplayernum, int myunitnum );
	UnitCommandCenter::UnitCommandCenter( Game *pgame );
	virtual ~UnitCommandCenter();

	//controls
//	virtual int action( int actionnum, Vector destpos );
	virtual int action( UnitCommand action );
	
	//render
	virtual int render(); // render this unit
	
	virtual int step();
	
	/// Returns a number of possible actions of this unit
	virtual int getNumberOfActions();
	/// Returns a action type where "number" is something between 0 and getNumberOfActions().
	virtual UnitCommand getActionType( int number );
	
	virtual void setUnitPosition( Vector pos ) { setPosition( pos ); }
	virtual Vector getUnitPosition( void ) { return getPosition(); }
private:
	//needed information
//	int playerNum; // number of this player
	tgl_object *model;

	Renderer *renderer;
	Game *game;
	Ground *ground;
	Player **players; //the other players including this
		
	//unit information
	int unitNum; // number of this unit
};


#endif
