/***************************************************************************
                          unitdestroyer.h  -  description
                             -------------------
    begin                : Wed Oct 17 2001
    copyright            : (C) 2001 by T Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UNITDESTROYER_H
#define UNITDESTROYER_H

#include "renderer.h"
#include "player.h"
#include "ground.h"
#include "allincludes.h"
#include "gamedefs.h"
#include "vector.h"
#include "airmovement.h"
#include "bulletweapon.h"
#include "unit.h"
#include "targetfinder.h"

/**Destroyer ship Unit
  *@author T Kontkanen
  */

class Player;
class Unit;

using namespace TGL;

class Game;

class UnitDestroyer : public Unit, AirMovement, BulletWeapon, TargetFinder {
public:
//	UnitDestroyer::UnitDestroyer( Game *pgame, int myplayernum, int myunitnum );
	UnitDestroyer::UnitDestroyer( Game *pgame );
	virtual ~UnitDestroyer();

	//controls
//	virtual int action( int actionnum, Vector destpos );
	virtual int action( UnitCommand action );
	
	//render
	virtual int render(); // render this unit
	
	virtual int step();
	
	virtual void setUnitPosition( Vector pos ) { setPosition( pos ); }
	virtual Vector getUnitPosition( void ) { return getPosition(); }

	/// Needed for death animation.
	virtual bool isAlive() {
		if( hitpoints>0 || death<1 ) return true; else return false;
	}
	/// Needed for smoking
	virtual void decreaseHitpoints( float amount, Vector hitposition ) {
		hitpoints-=amount;
		if( hitpoints < 0 ) hitpoints=0;
		getting_damage=true;
		hitpos=hitposition;
	}

	virtual bool isMoving() { if( velocity != 0 ) return true; else return false; } //DIRECT
private:
	//needed information
//	int playerNum; // number of this player
	tgl_object *model;
	Vector linep1, linep2; //line pos
	Color linecol; //line color
	Texture *particle;
	float death;
	bool getting_damage;
	Vector hitpos;
	
	Renderer *renderer;
	Game *game;
	Ground *ground;
	Player **players; //the other players including this
		
	//unit information
	int unitNum; // number of this unit
};

#endif
