/***************************************************************************
                          unitid.h  -  description
                             -------------------
    begin                : Fri Oct 26 2001
    copyright            : (C) 2001 by T Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UNITID_H
#define UNITID_H


/**Class for an unique ID for Units.
  *@author T Kontkanen
  */

class Game;
class Player;

class UnitID {
public: 
	UnitID();
//	~UnitID();
	/// Returns current ID.
	inline int getID() const { return id; }
	
	/// An equal comparsion operator for UnitID.
	inline bool operator==(const UnitID& uid) {
		if( uid.id==id ) return true;
		else return false;
	}
	
	inline int getPlayernum() const { return playernum; }
	inline int getUnitnum() const { return unitnum; }

protected:
	/// Sets ID, only Game class can do this.
	inline void setID( int newid ) { id=newid; }
	
	/// Following set/get methods are used in iteration.
	inline void setUnitnum( int num ) { unitnum=num; }
	inline void setPlayernum( int num ) { playernum=num; }
	inline int getSearchPlayernum() const { return searchplayernum; }
	inline void setSearchPlayernum( int num ) { searchplayernum=num; }
	
	int id;
	int unitnum, playernum, searchplayernum; // warning: Game::getUnit uses these variabled directly
private:
	/// An unique ID
	
	friend Game; friend Player;
};

#endif
