#ifndef _DEMETER_DRAWABLE_
#define _DEMETER_DRAWABLE_

#include <osg/BoundingBox>
#include <osg/StateSet>
#include <osg/State>
#include <osg/Types>
#include <osg/Drawable>
#include "Terrain.h"

namespace Demeter
{
	class TERRAIN_API DemeterDrawable : public osg::Drawable
	{
		public:
										DemeterDrawable();
										DemeterDrawable(const DemeterDrawable&);
			virtual 					~DemeterDrawable();
			virtual osg::Object*		clone() const;
			void						SetTerrain(Terrain* pTerrain);
			DemeterDrawable& 			operator = (const DemeterDrawable&) ;
			virtual const char* 		className() const;
			/// Demeter does not currently support display lists - see Demeter source for discussion
			void 						setUseDisplayList(const bool flag);
			virtual void 				drawImmediateMode(osg::State&);
		protected:
			virtual const bool 			computeBound() const;
			osg::ref_ptr<Terrain>		m_RefTerrain;
	};
};

#endif
