import demeter.*;
import java.util.*;
import java.io.*;

public class TestDemeter
{
    public TestDemeter(String mapFilename,String mediaPath)
    {
    	Terrain.setMediaPath(mediaPath);
    	Terrain.createRenderWindow(800, 600, 32, false);
        Terrain terrain = new Terrain(mapFilename, 80000);
    	terrain.setDetailThreshold(100.0f);
		long startTime = System.currentTimeMillis();
		float camx = 2000.0f;
		float camy = 2000.0f;
		for (int i = 0; i < 1000; i++)
		{
			Terrain.setCameraPosition(camx += 1.0f, camy += 0.5f, 300, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 1.0f);
			Terrain.clearBuffers();
			terrain.render();
			Terrain.swapBuffers();
		}
		float fps = 1000.0f / ((System.currentTimeMillis() - startTime) / 1000.0f);
		System.out.println("Ran at " + fps + " frames per second.");
    }
    
    public static void main(String[] args)
    {
        if (args.length == 2)
        {
        	File file = new File(args[1]);
        	if (file.exists() && file.isDirectory())
        	{
        		file = new File(args[1] + File.separator + args[0]);
        		if (file.exists() && !file.isDirectory())
		            new TestDemeter(args[0],args[1]);
		        else
		        	System.out.println("Specified map file (" + args[0] + ") does not exist in specified media path.");
        	}
        	else
        		System.out.println("Specified media path (" + args[1] + ") does not exist.");
        }
        else
            showUsage();          
    }
    
    private static void showUsage()
    {
        System.out.println("USAGE: java TestDemeter <mapname> <mediapath>");
    }
}

