package demeter;

public class Terrain
{
    static
    {
        try
        {
            System.loadLibrary("DemeterJNI");
            init();
        }
        catch(Exception ex)
        {
            System.out.println("Failed to load Demeter!");    
        }
    }
    
    private int terrainIndex;
    private float[] vector3DElements = new float[3];
    
    public static native void createRenderWindow(int width, int height, int colorDepth, boolean fullscreen);
    public static native void setMediaPath(String mediaPath);
    public static native void swapBuffers();
    public static native void clearBuffers();
	public static native void setCameraPosition(float posX, float posY, float posZ, float lookAtX, float lookAtY, float lookAtZ, float lookUpX, float lookUpY, float lookUpZ, float viewPlaneDistance);

    private native int createNativeTerrain(String mapFilename, int maxNumTriangles);
    private static native void init();
 	
    private static native void setDetailThreshold(int terrainIndex, float threshold);
    public void setDetailThreshold(float threshold)
    {
        setDetailThreshold(terrainIndex, threshold);
    }
 
    private native void render(int terrainIndex);
    public void render()
    {
    	render(terrainIndex);	
    }
    
    private native void getElevation(int terrainIndex,float x,float y);
    public void getElevation(float x,float y)
    {
    	getElevation(terrainIndex,x,y);	
    }

    private native void getNormal(int terrainIndex,float x,float y,float[] vector3D);
    public void getNormal(float x,float y,Vector3D normal)
    {
    	normal.getElements(vector3DElements);
    	getNormal(terrainIndex,x,y,vector3DElements);
    	normal.setElements(vector3DElements);
    }

    public Terrain(String mapFilename, int maxNumTriangles)
    {
        terrainIndex = createNativeTerrain(mapFilename, maxNumTriangles);
    }
}
