
/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mon Jun 26 21:54:56 EEST 2000
    copyright            : (C) 2000 by Tero Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "/home/tero/devel/executor/support/glpng/include/GL/glpng.h"
#include <iostream.h>
#include <stdlib.h>
#include "tgl.h"


using namespace TGL;

/*    static float ambient[] = {0.0, 0.0, 0.1, 1.0};
    static float diffuse[] = {0.7, 0.7, 0.8,1.0};
    static float position0[] = {-10.0, 10.0, 10.0, 0.0};
    static float front_mat_shininess[] = {60.0};
    static float front_mat_specular[] = {0.2, 0.3, 0.5, 1.0};
    static float front_mat_diffuse[] = {0.6, 0.48, 0.58, 1.0};*/

    static float ambient[] = {0.0, 0.0, 0.1, 1.0};
    static float diffuse[] = {1.0, 1, 1.0,1.0};
    static float position0[] = {-10.0, 10.0, 10.0, 0.0};
    static float front_mat_shininess[] = {30.0};
    static float front_mat_specular[] = {1, 1, 1.0, 1.0};
    static float front_mat_diffuse[] = {1, 1, 1.00, 1.0};

SDL_Event event;
int keys[512];
int mx, my, mb[3]={0,0,0};
float xrot=0, yrot=0, zoom=10;
tgl_camera *camera;
tgl_object *obu, *back, *test;

GLboolean CheckError( const char *message )
{
   GLenum error = glGetError();
   if (error) {
      char *err = (char *) gluErrorString( error );
      fprintf( stderr, "GL Error: %s at %s\n", err, message );
      return GL_TRUE;
   }
   return GL_FALSE;
}


void init_sdl()
{
	if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) {
		fprintf(stderr,"Couldn't initialize SDL: %s\n",SDL_GetError());
		exit( 1 );
	}

//	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
//	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
//	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );

	SDL_GL_SetAttribute(SDL_GL_BUFFER_SIZE,24);
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1);
	SDL_WM_SetCaption( "tgl test", "tgl" );

	if ( SDL_SetVideoMode( SCREEN_W, SCREEN_H, DEPTH, SDL_OPENGL|SDL_DOUBLEBUF/*|SDL_FULLSCREEN*/ )== NULL ) {
		fprintf(stderr, "Couldn't set GL mode: %s\n", SDL_GetError());
		SDL_Quit();
		exit(1);
	}

}

void render()
{
	static float pos=0, adder=0.01;
	static int toframe=1, fromframe=0, init=2;

/*	if( init>0 )
	{
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
		init--;
	}*/

/*	glDisable( GL_DEPTH_TEST );
	glDisable( GL_TEXTURE_2D );
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
//	glBlendFunc( GL_ONE, GL_ONE );
	glEnable( GL_BLEND );

	glBegin( GL_QUADS );
	glColor4f( 0.00,0.00,0.00, 0.15 );
	glVertex3f( -10, -10, -1.5 );
	glVertex3f( 10, -10, -1.5 );
	glVertex3f( 10, 10, -1.5 );
	glVertex3f( -10, 10, -1.5 );
	glEnd();

	glDisable( GL_BLEND );*/




	glClear( GL_DEPTH_BUFFER_BIT );
	glClear( GL_COLOR_BUFFER_BIT );
//	glDisable( GL_DEPTH_TEST ); // toisinpin blurrissa
	glEnable( GL_DEPTH_TEST );
//	camera->set_angle( M_PI, 0 );
	camera->set_angle( -xrot/200.0, -yrot/200.0 );
//	camera->set_position( 0, 0, zoom );
	camera->move_forward( 0, 0, zoom/3.0 );
//	camera->move_forward( 0, zoom/3.0, 0 );
//	camera->move_forward(  zoom/3.0,0,0 );
	zoom = 0;
	camera->set_view();
	glLightfv(GL_LIGHT0, GL_POSITION, position0);

	// animate
	pos += adder;
	if( pos > 1.0 )
	{
		pos=0;

		toframe++;
		fromframe++;
		if( toframe >= obu->numframes ) toframe = 0;
		if( fromframe >= obu->numframes ) fromframe = 0;
	}
	obu->set_morph( fromframe, toframe );
	obu->morph(pos);


	// rotate
//	obu->move( 0,0,10 );

//	back->move( 0, 0, -5 );
//	back->draw();
//	obu->scale( 0.2, 0.2, .2 );
//	obu->rotate( 1, 0, 0, yrot );
//	obu->rotate( 0, 1, 0, xrot );

//	obu->draw = obu->draw_triangles();
//	obu->draw_triangles();
	obu->rotate(90,0,1,0);
	obu->draw();
	obu->rotate(90,0,1,0);
	obu->move(50,0,0);
	obu->draw();

//	test->draw();

/*	glDisable( GL_DEPTH_TEST );
	glBlendFunc( GL_ONE_MINUS_DST_COLOR, GL_ZERO );
	glEnable( GL_BLEND );
	glDisable( GL_TEXTURE_2D );
	glBegin( GL_QUADS );
	glColor4f( 1,1,1,1 );
	glVertex3f( -10, -10, -1.5 );
	glVertex3f( 10, -10, -1.5 );
	glVertex3f( 10, 10, -1.5 );
	glVertex3f( -10, 10, -1.5 );
	glEnd();
	glDisable( GL_BLEND );*/

	SDL_GL_SwapBuffers( );

/*	glDisable( GL_DEPTH_TEST );
	glBlendFunc( GL_ONE_MINUS_DST_COLOR, GL_ZERO );
	glEnable( GL_BLEND );
	glDisable( GL_TEXTURE_2D );
	glBegin( GL_QUADS );
	glColor4f( 1,1,1,1 );
	glVertex3f( -10, -10, -1.5 );
	glVertex3f( 10, -10, -1.5 );
	glVertex3f( 10, 10, -1.5 );
	glVertex3f( -10, 10, -1.5 );
	glEnd();
	glDisable( GL_BLEND );*/


	// guess :)
	CheckError("render");
}

int HandleSDL ( SDL_Event *event )
{
	int done = 0;

	switch ( event->type )
	{
		case SDL_QUIT:
			done = 1;
			break;

		case SDL_KEYDOWN:
			if ( event->key.keysym.sym == SDLK_ESCAPE ) done = 1;
			keys[event->key.keysym.sym] = true;
			break;

		case SDL_KEYUP:
			keys[event->key.keysym.sym] = false;
			break;

		case SDL_MOUSEMOTION:
			my = event->motion.yrel;
			mx = event->motion.xrel;
			break;

		case SDL_MOUSEBUTTONDOWN:
			mb[event->button.button-1] = 1;
			break;

		case SDL_MOUSEBUTTONUP:
			mb[event->button.button-1] = 0;
			break;

		case SDL_ACTIVEEVENT:
			if( !event->active.gain )
				if( event->active.state & SDL_APPMOUSEFOCUS )
				{
					mb[0]=mb[1]=mb[2]=0;
				}
			break;
	}

	return done;
}

void handle_input()
{
		static int pr=0;

	if( mb[0] )
	{
		xrot += mx;
		yrot += my;
	} else if( mb[2] )
		zoom += (float)my/4.0;

	if( mb[1] )
	{
		delete( obu );
		if( pr < 10 )
	obu = new tgl_object( "/files/3d/torvi.t3d" );
//			obu = new tgl_object( "/home/tero/devel/3d/samplemodeltn.t3d" );
		else
			obu = new tgl_object( "/home/tero/devel/3d/samplemodelt.t3d" );
		pr++;
		obu->print_info();
	}
//	obu = new tgl_object( "/files/3d/torvi.t3d" );
//	obu = new tgl_object( "/files/3d/pytty.t3d" );
//		obu = new tgl_object( "/files/3d/observer.t3d" );
	if( keys[SDLK_c] )
		obu->coloring = 0;
	if( keys[SDLK_c] & keys[SDLK_RSHIFT] )
		obu->coloring = 1;
	if( keys[SDLK_l] )
		obu->lighting = 0;
	if( keys[SDLK_l] & keys[SDLK_RSHIFT] )
		obu->lighting = 4;
	if( keys[SDLK_t] )
		obu->texturing = 0;
	if( keys[SDLK_t] & keys[SDLK_RSHIFT] )
		obu->texturing = 1;

	mx = my = 0;
}

int mainloop()
{
	int done=0;

	while ( !done )
	{
		SDL_Delay( 10 );
		while ( SDL_PollEvent ( &event ) )
		{
			done = HandleSDL ( &event );
		}
		handle_input();
		render();
	}
}


int main(int argc, char *argv[])
{
	float rot=0, mov=0;
  int i;

//	tgl_disable_lighting=true;
//	tgl_debug=2;
	tgl_setmode( 800, 600, TGL_WINDOWED, 16 );
	init_sdl();
	tgl_init(26);
//	tgl_object_rendermode = TGL_ELEMENTS;
//	texturemode = 0;
	camera = new tgl_camera();
// 	camera->up[1]=0;	camera->up[2]=1;
	camera->move( 3,0, 0 );
	camera->set_angle( M_PI, 0 );
//	camera->move( 0, 6, 10 );
//	camera->set_angle( M_PI, -.6 );
//	camera->set_view();


	// init gl
//	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
	glLightModelfv( GL_LIGHT_MODEL_AMBIENT, ambient );
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
	glLightfv(GL_LIGHT0, GL_POSITION, position0);
	glEnable(GL_LIGHT0);


	glDepthFunc( GL_LESS );
	glClearColor( 0,0,0, 0 );
	glClearDepth( 1.0 );
	glEnable( GL_DEPTH_TEST );

	//executorvars
	glClearColor(0.5f,0.75f,1.0f,0.0f);
	glDisable(GL_NORMALIZE);
	glEnable(GL_DEPTH_TEST);
	glClearDepth( 1.0 );
	glShadeModel(GL_SMOOTH);

	float fogc[]={1,1,1,1};
	//glEnable(GL_FOG);
	glFogf(GL_FOG_MODE,GL_EXP2 );
	glFogf(GL_FOG_DENSITY,0.015); //exp
	glFogfv(GL_FOG_COLOR,fogc);
	glFogf(GL_FOG_START,100.0f);
	glFogf(GL_FOG_END,200);
//	glFogf(GL_FOG_END,maxViewDistance - 100.0f);
			glDisable( GL_CULL_FACE );
			glDisable(GL_NORMALIZE);
			glEnable(GL_DEPTH_TEST);
			glColor4f( 1,1,1,1 );
			glClearDepth( 1.0 );
			glShadeModel(GL_SMOOTH);
//			glEnable(GL_FOG);
			glBlendFunc( GL_ONE, GL_ONE );
			glDisable( GL_BLEND );

//	pngInfo info;
//	int glpng_alpha;
//	int mipmapping, ret;
//	glpng_alpha=PNG_ALPHA;
//	mipmapping=PNG_BUILDMIPMAPS;
//	pngSetStencil( 255, 255, 255 );
//	glPixelStorei( GL_UNPACK_ROW_LENGTH, 0 ); //GL defaults
//	glPixelStorei( GL_UNPACK_ALIGNMENT,4 );
//
//	ret=pngBind( "/files/executor/fonts/v11.png", mipmapping, glpng_alpha, &info, GL_CLAMP,GL_LINEAR,GL_LINEAR);

//	if( ret ){
//		printf("texture png ok\n");
//	} else
//	{
//		printf("texture png FAILED!\n");
//	}



	test = new tgl_object( "/files/3d/pytty.t3d" );
//	tgl_object_rendermode = TGL_ELEMENT;
  back = new tgl_object( "/files/3d/cylinder.t3d" );
//  obu = new tgl_object( "/files/3d/qube.t3d" );
//obu = new tgl_object( "/files/3d/basic.t3d" );
//  obu = new tgl_object( "/files/3d/fema4tex.t3d" );
//  obu = new tgl_object( "/files/3d/edittest.t3d" );
  //obu = new tgl_object( "/home/tero/devel/3d/samplemodelanim.t3d" );
//obu = new tgl_object( "/files/executor/models/bcruiser.t3d" );
obu = new tgl_object( "/home/tero/3d/relpath.t3d" );
//obu->pre_scale( 2,1,1 );
//	obu = new tgl_object( "/files/3d/tglsave101.t3d" );
//	obu->save_t3dmodel( "/files/3d/tglsave101.t3d", 101 );
//	obu->save_t3dmodelbin( "/files/3d/track.t3dbin", 101 );
//	obu = new tgl_object( "/files/3d/torvi.t3d" );
//	obu = new tgl_object( "/files/3d/pytty.t3d" );
//		obu = new tgl_object( "/files/3d/observer.t3d" );
//		obu = new tgl_object( "/files/3d/torustex.t3d" );
//		obu = new tgl_object( "/files/3d/torusn.t3d" );
//	delete_unused_textures();
//  obu->texturing=0;


//	obu->calcnormals();
	//test->calcnormals();

/*	{
	float x=0, y=0, z=0;
	int f, nf, nv;
	nf=obu->numframes;
	nv=obu->numvertices;

	for(f=0; f<nf; f++ )
		for(i=0; i<nv; i++ )
		{
			obu->vertices[i+nv*f].tex[0] = obu->vertices[i+nv*f].vec[0]/2.0+0.5;
			obu->vertices[i+nv*f].tex[1] = obu->vertices[i+nv*f].vec[1]/2.0+0.5;
		}
	}*/

/*  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP); // Set The Texture Generation Mode For S To Sphere Mapping (NEW)
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP); // Set The Texture Generation Mode For T To Sphere Mapping (NEW)
  glEnable(GL_TEXTURE_GEN_S);                    // Enable Texture Coord Generation For S (NEW)
  glEnable(GL_TEXTURE_GEN_T);                    // Enable Texture Coord Generation For T (NEW)
*/

/// test texture change
/*	tgl_texturecache = TGL_MANUALUNLOAD;
  obu->change_texture( 0, "/home/tero/devel/3d/metaln.pcx" );
  obu->change_texture( 1, "notexture" );
  obu->change_texture( 2, "notexture" );
  obu->change_texture( 3, "notexture" );
  delete_unused_textures();

  obu->change_texture( 0, "/home/tero/devel/3d/metaln.pcx" );
  obu->change_texture( 1, "/home/tero/devel/3d/metal_n.pcx" );
  obu->change_texture( 2, "/home/tero/devel/3d/metal.pcx" );
  obu->change_texture( 3, "/home/tero/devel/3d/metal.pcx" );
  delete_unused_textures();
	tgl_texturecache = TGL_AUTO;*/
//	obu->change_texture( 0, "/down/files/3d/wood.pcx" );
	obu->change_texture( 0, "wood.pcx" );

/*  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP); // Set The Texture Generation Mode For S To Sphere Mapping (NEW)
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP); // Set The Texture Generation Mode For T To Sphere Mapping (NEW)
  glEnable(GL_TEXTURE_GEN_S);                    // Enable Texture Coord Generation For S (NEW)
  glEnable(GL_TEXTURE_GEN_T);                    // Enable Texture Coord Generation For T (NEW)
*/


	mainloop();

	delete(obu);
	delete(back);
	delete(test);
	delete_unused_textures();

	delete(camera);
	remove_tgl();

  exit( EXIT_SUCCESS );
}
