/***************************************************************************
                          tgl_camera.h  -  description
                             -------------------
    begin                : Mon Jun 26 2000
    copyright            : (C) 2000 by Tero Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef TGL_CAMERA_H
#define TGL_CAMERA_H


//#include <SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include "tgl.h"


namespace TGL{
/**
  *@author Tero Kontkanen
  */

class tgl_camera {
public:
	//init
	tgl_camera();
	~tgl_camera();
	
	//view
	int set_view();
	
	//modify
	int rotate( float rx, float ry, float rz );
	int move( float mx, float my, float mz );
	int tgl_camera::set_angle( float angle, float pitch );
	int tgl_camera::set_position( float mx, float my, float mz );
	int tgl_camera::move_forward( float mx, float my, float mz );

	//vars
	float x, y, z;
	float rot_x, rot_y, rot_z, up[3];
	float lookat_x, lookat_y, lookat_z;
	int rotate1st, rotate2nd, rotate3rd; // 0=x, 1=y, 2=z
	float near_clip, far_clip;
	int view_x,view_y,view_w,view_h;
};


}
#endif
