/***************************************************************************
                          tgl_heightfield.h  -  description
                             -------------------
    begin                : Fri Dec 15 2000
    copyright            : (C) 2000 by Tero Kontkanen
    email                : tkontkanen@mail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "tgl.h"
#include <GL/gl.h>

#ifndef TGL_HEIGHTFIELD_H
#define TGL_HEIGHTFIELD_H

namespace TGL{


/**Class for landscape rendering with level of detail control.
  *@author Tero Kontkanen
  */


class tgl_heightfield {
public:
	tgl_heightfield( char *fname );
	~tgl_heightfield();
	GLvoid rotate( GLfloat x, GLfloat y, GLfloat z, GLfloat amount );
	GLvoid move( GLfloat x, GLfloat y, GLfloat z );
	GLvoid scale( GLfloat x, GLfloat y, GLfloat z );
	GLint draw();
	void calcnormals( void );
//	void print_info( void );

	char name[64], filetype;
	int texturing, coloring, lighting, hfre;
	int numindices, numvertices;
	int src_blendfunc, dest_blendfunc;

	// vars
	TVERTEX *vertices;
	TVERTEX *currframe;
	TVERTEX *vertexmorph;
	GLuint *indices;
	GLuint *currindices;
	GLuint *textures;
	TMATERIAL material; // diffuse, shiness, specular...

private:
	// file io
	void calcnormal( int i1, int i2, int i3 );
	void normalize( void );
};

}//namespace

#endif
